% This is a second order electromagnetically actuated mass spring
% damper system, described in
%
%  R. H. Miller, I. Kolmanovsky, E. G. Gilbert, and P. D. Washabaugh.
%     Control of constrained nonlinear systems: a case study.  IEEE
%     Control Systems Magazine, 20(1):23--32, 2000. 


function xdot = spring(x,t)

global uk wk

u = uk;

alpha = 4.5e-5;
gamma = 1.99;
c = 0.6590;
k = 38.94;
d0 = .0102;
m = 1.54;

xdot(1) = x(2);
xdot(2) = -(k/m)*x(1) - (c/m)*x(2) + (alpha/m)*(u/(d0-x(1))^gamma);

if (x(1) > .0101)
  xdot(2) = -(k/m)*x(1) - (c/m)*x(2) + (alpha/m)*(u/(d0-.0101)^gamma);
end
